/**
 * 
 */
package hu.bme.mit.example.codegenerator.jetexample;

import java.util.Map;

import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;

import PetriNets.petrinet.PetriNet;
import PetriNets.petrinet.PetrinetPackage;

/**
 * @author Akos Horvath
 *
 */
public class PNMLJetGenerator {
	
	public boolean generatePNML(IResource fileResource){
		/** Get package **/
		PetrinetPackage.eINSTANCE.eClass();
		
		// Register the XMI resource factory for the .petrinet extension (local!)

		Resource.Factory.Registry reg = Resource.Factory.Registry.INSTANCE;
		Map<String, Object> m = reg.getExtensionToFactoryMap();
		m.put("petrinet", new XMIResourceFactoryImpl());

		// Obtain a new resource set
		ResourceSet resSet = new ResourceSetImpl();
		
		//create a resource reference on the EMF serialized from
		Resource resource = resSet.getResource(URI.createURI(fileResource.getRawLocationURI().toASCIIString()), true);
		// Get the first model element and cast it to the right type, usually the root element
		
		//finish the code by getting the model /resource.getContents().get(0); :-)
		PetriNet pn = (PetriNet) resource.getContents().get(0);
		
		
		Job myJob = new Petrinet2PNMLJetJob("MyPetriJob", fileResource, pn);
		myJob.schedule();
		
		return true;
	}

}
