package hu.bme.mit.example.codegenerator.jetexample;

import java.io.FileWriter;

import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.jobs.Job;

import PetriNets.petrinet.PetriNet;

public class Petrinet2PNMLJetJob extends Job {

	IResource fileResource;
	PetriNet petrinet;
	
	public Petrinet2PNMLJetJob(String name, IResource fileResource, PetriNet petriNet) {
		super(name);
		this.fileResource = fileResource;
		this.petrinet= petriNet;
	}
	
	@Override
	protected IStatus run(IProgressMonitor monitor) {
		try {
			monitor.beginTask("Generate PNML" , monitor.UNKNOWN);
			// setup

			// TODO invoke JET template here
			String result = ""; 
			
			FileWriter writer = new FileWriter(fileResource.getLocation()
					.addFileExtension("pnml").toOSString());
		
			writer.write(result);
			//writer.flush();
			writer.close();
		} catch (Exception e) {
			System.out.println(e);
		}
		monitor.done();
		return org.eclipse.core.runtime.Status.OK_STATUS;
	}
}
