/**
 * 
 */
package hu.bme.mit.example.codegenerator.handler;

import hu.bme.mit.example.codegenerator.jetexample.PNMLJetGenerator;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.core.resources.IResource;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.handlers.HandlerUtil;

/**
 * @author Akos Horvath
 *
 */
public class PNMLGeneratorHandler extends AbstractHandler implements IHandler {
	
	public Object execute(ExecutionEvent event) throws ExecutionException {
		ISelection selection =  HandlerUtil.getCurrentSelection(event);
		Object obj = ((IStructuredSelection)selection).getFirstElement();
		if(obj instanceof IResource)
			{
			IResource fileResource = (IResource)obj; 
			//PNMLVelocityGenerator vGenerator = new PNMLVelocityGenerator();
			PNMLJetGenerator vGenerator = new PNMLJetGenerator();
			vGenerator.generatePNML(fileResource);
			}
		return null;
	}

}
